Object = class()

function Object:__init(image, x, y)
  self.id = 0 -- object manager
  
  self.gpath = image
  self.image = love.graphics.newImage(self.gpath)
  self.quadid = 1
  self.quads = {}
  self.drawmode = 1
  
  self.animtimer = 0
  
  self.x = x
  self.y = y
  self.viewx = x
  self.viewy = y
  
  self.w = 16
  self.h = 16
  self.solid = true
end

function Object:setQuad(id)
  self.quadid = id
end

function Object:draw()
  if self.drawmode ~= 2 then
    love.graphics.draw(self.image, self.viewx, self.viewy)
  end
end

function Object:getQuad(id)
  return self.quads[id]
end

function Object:setDrawMode(mode, qs)
  self.drawmode = mode
  if mode == 1 then
    self.quads = {}
  else
    self:setupQuads(qs)
  end
end

function Object:animate(from, to)
  if not (self.quadid < (to and to or #self.quads) and self.quadid >= (from and from or 1)) then
      self.quadid = (from and from or 1)
  end
  
  if self.animtimer > 0.2 then
    self.animtimer = 0
    if self.quadid < (to and to or #self.quads) and self.quadid >= (from and from or 1) then
      self.quadid = self.quadid + 1
    else
      self.quadid = (from and from or 1)
    end
  end
  self:setDraw()
end

function Object:setupQuads(qs)
  self.quadid = 1
  self.quads = {}
  
  for x=1, #qs do
    self.quads[x] = love.graphics.newQuad((qs[x].x) * self.w, (qs[x].y * self.h), self.w, self.h, self.image:getDimensions()) 
  end
end

function Object:move(x, y)
  if x and x ~= 0 then
    self.x = self.x + x
  end
  
  if y and y ~= 0 then
    self.y = self.y + y
  end
end

function Object:getX()
  return self.x
end

function Object:getY()
  return self.y
end

function Object:setPosition(x, y)
  self.x = x
  self.y = y
end

function Object:isSolid()
  return self.solid
end

function Object:setSolid(s)
  self.solid = s
end
