love.filesystem.load("Dependencies.lua")()

function love.load()
  DeltaTime = 0
  player = Player("Featzen", "graphics/player_tileset.png")
  player:setPosition(0, 0)
  player:setDrawMode(2)  
  
  Map = Layer("graphics/tileset.png", CONFIG.WORLDW, CONFIG.WORLDH, love.graphics.getWidth(), love.graphics.getHeight())
  ObjectLayer = Layer("graphics/tileset.png", CONFIG.WORLDW, CONFIG.WORLDH, love.graphics.getWidth() , love.graphics.getHeight())
  
  Map:setDefaultQuad(1)
  
  ObjectLayer:syncPos(player:getX(), player:getY())
  Map:syncPos(player:getX(), player:getY())
  
  for x=1, 50 do
    if math.random(1,2) < 2 then
      ObjectLayer:setMapQuad(x, x, ((ObjectLayer.image:getWidth() / 16) * 4) - 11)
    end
  end
  
  Map:update()
  ObjectLayer:update()
end

function love.update(dt)
  DeltaTime = dt
  player:onThink(dt)
  if love.keyboard.isDown("left") then
    player:move(-1, 0)
    player:animate(4, 6)
  elseif love.keyboard.isDown("right") then
    player:move(1, 0)
    player:animate(10, 12)
  elseif love.keyboard.isDown("up") then
    player:move(0, -1)
    player:animate(7, 9)
  elseif love.keyboard.isDown("down") then
    player:move(0, 1)
    player:animate(1, 3)
  end
  
  Map:syncPos(player:getX(), player:getY())
  ObjectLayer:syncPos(player:getX(), player:getY())
end

function love.keyreleased(key)
  if key == "left" then
    player:setQuad(4)
  elseif key == "right" then
    player:setQuad(10)
  elseif key == "up" then
    player:setQuad(7)
  elseif key == "down" then
    player:setQuad(1)
  end
end

function love.draw()
    Map:draw()
    ObjectLayer:draw()
    player:draw()
    love.graphics.print("FPS: " .. love.timer.getFPS(), 0, 0)
    love.graphics.print("Player X: " .. player:getX(), 0, 20)
    love.graphics.print("Player Y: " .. player:getY(), 0, 30)
    love.graphics.print("ScreenWidth: " .. love.graphics.getWidth(), 0, 50)
    love.graphics.print("ScreenHeight: " .. love.graphics.getHeight(), 0, 60)
    
end
